import React from 'react';
import styled from 'styled-components';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  position: absolute;\n  top: 5px;\n  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.25);\n  border: solid 1px #f0f5f1;\n  border-radius: 4px;\n  cursor: pointer;\n  transition: all 300ms ease;\n  background: #fff;\n  height: ", "rem;\n  width: ", "rem;\n  opacity: 1;\n\n  @media (max-width: 56.25em) {\n  }\n\n  @media (max-width: 37.5em) {\n    margin-left: -", "rem;\n  }\n\n  @media (max-width: 25em) {\n    top: 0;\n    height: ", "rem;\n    width: ", "rem;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  position: relative;\n  overflow: hidden;\n  height: ", "rem;\n  padding-left: calc((100% - ", "rem) / 2);\n  @media (max-width: 56.25em) {\n  }\n\n  @media (max-width: 37.5em) {\n    display: flex;\n    justify-content: center;\n  }\n\n  @media (max-width: 25em) {\n    height: ", "rem;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Carousel = styled.div(_templateObject(), function (props) {
  return props.height + 2;
}, function (props) {
  return 2.9 * props.width / 2;
}, function (props) {
  return props.height / 1.3 + 1;
});
var CarouselItem = styled.div(_templateObject2(), function (props) {
  return props.height;
}, function (props) {
  return props.width;
}, function (props) {
  return props.width / 3.5;
}, function (props) {
  return props.height / 1.3;
}, function (props) {
  return props.width / 1.3;
});

var SCALE_UNIT = 0.1;
var SHIFT_UNIT = 90;
var BIG_SHIFT_UNIT = 130;

var TemplateCarousel = /*#__PURE__*/function (_React$PureComponent) {
  _inheritsLoose(TemplateCarousel, _React$PureComponent);

  function TemplateCarousel() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _this.renderTemplateThumbnails = function () {
      var _this$props = _this.props,
          height = _this$props.height,
          width = _this$props.width,
          children = _this$props.children,
          id = _this$props.id;
      console.log('props', _this.props);
      var totalTemplates = children.length;
      return children.map(function (child, i) {
        var zIndex = totalTemplates - i;
        var scale = 1 - i * SCALE_UNIT;
        var xAxis = 90 - i * SHIFT_UNIT;
        return /*#__PURE__*/React.createElement(CarouselItem, {
          key: parseInt(i, 10),
          style: {
            transform: "scale(" + scale + ") translateX(" + xAxis + "px)",
            right: 'inherit',
            zIndex: zIndex
          },
          height: height,
          width: width,
          className: "template-carousel__template-" + id,
          "data-position": -1 * i,
          "data-zindex": zIndex,
          "data-scale": scale,
          "data-xaxis": xAxis,
          "data-order": i,
          "data-is-active": i === 0 ? 'yes' : 'no',
          role: "link",
          tabIndex: 0
        }, child);
      });
    };

    _this.onTemplateClick = function (e, targetCard1, targetCardPos1) {
      if (targetCard1 === void 0) {
        targetCard1 = null;
      }

      if (targetCardPos1 === void 0) {
        targetCardPos1 = null;
      }

      console.log('template clickded');
      var targetCard = targetCard1 || e.target.closest(".template-carousel__template-" + _this.props.id);
      var targetCardPos = targetCardPos1 || parseInt(targetCard.dataset.position, 10);
      if (targetCardPos < 0) for (var a = 0; a < _this.allCards.length; a += 1) {
        _this.allCards[a].setAttribute('data-is-active', 'no');

        _this.moveCard(_this.allCards[a], targetCardPos);
      } else if (targetCardPos > 0) for (var _a = _this.allCards.length - 1; _a >= 0; _a -= 1) {
          _this.allCards[_a].setAttribute('data-is-active', 'no');

          _this.moveCard(_this.allCards[_a], targetCardPos);
        }
      targetCard.setAttribute('data-is-active', 'yes');
    };

    _this.moveCard = function (cardToMove, targetCardPos) {
      var transform = function transform(newScale, newPos) {
        cardToMove.style.transform = "scale(" + newScale + ") translateX(" + newPos + "px)";
        cardToMove.setAttribute('data-xaxis', newPos);
        cardToMove.setAttribute('data-scale', newScale);
      };

      var move = function move(steps) {
        var curCardPos = parseInt(cardToMove.dataset.position, 10);
        return {
          scaleUp: function scaleUp() {
            cardToMove.style.zIndex = parseInt(cardToMove.dataset.zindex, 10) + steps;
            cardToMove.setAttribute('data-zindex', parseInt(cardToMove.dataset.zindex, 10) + steps);
            return parseFloat(cardToMove.dataset.scale) + steps * SCALE_UNIT;
          },
          scaleDown: function scaleDown() {
            cardToMove.style.zIndex = parseInt(cardToMove.dataset.zindex, 10) - steps;
            cardToMove.setAttribute('data-zindex', parseInt(cardToMove.dataset.zindex, 10) - steps);
            return parseFloat(cardToMove.dataset.scale) - steps * SCALE_UNIT;
          },
          moveRight: function moveRight() {
            cardToMove.setAttribute('data-position', parseInt(cardToMove.dataset.position, 10) + steps);
            return parseInt(cardToMove.dataset.xaxis, 10) + steps * (curCardPos >= 0 ? BIG_SHIFT_UNIT : SHIFT_UNIT);
          },
          moveLeft: function moveLeft() {
            cardToMove.setAttribute('data-position', parseInt(cardToMove.dataset.position, 10) - steps);
            return parseInt(cardToMove.dataset.xaxis, 10) - steps * (curCardPos > 0 ? BIG_SHIFT_UNIT : SHIFT_UNIT);
          }
        };
      };

      var currentPosOfCardToMove = parseInt(cardToMove.dataset.position, 10);
      var totalStepsToMove = Math.abs(targetCardPos);
      var firstDirectionSteps;
      var secondDirectionSteps;

      if (Math.abs(currentPosOfCardToMove) >= totalStepsToMove) {
        firstDirectionSteps = totalStepsToMove;
        secondDirectionSteps = 0;
      } else {
        firstDirectionSteps = Math.abs(currentPosOfCardToMove);
        secondDirectionSteps = totalStepsToMove - firstDirectionSteps;
      }

      if (targetCardPos < 0) {
        if (currentPosOfCardToMove < 0) {
          transform(move(firstDirectionSteps).scaleUp(), move(firstDirectionSteps).moveRight());
          transform(move(secondDirectionSteps).scaleDown(), move(secondDirectionSteps).moveRight());
        } else {
          transform(move(totalStepsToMove).scaleDown(), move(totalStepsToMove).moveRight());
        }
      } else if (targetCardPos > 0) {
        if (currentPosOfCardToMove <= 0) {
          transform(move(totalStepsToMove).scaleDown(), move(totalStepsToMove).moveLeft());
        } else {
          transform(move(firstDirectionSteps).scaleUp(), move(firstDirectionSteps).moveLeft());
          transform(move(secondDirectionSteps).scaleDown(), move(secondDirectionSteps).moveLeft());
        }
      }
    };

    return _this;
  }

  var _proto = TemplateCarousel.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.allCards = Array.from(document.getElementsByClassName("template-carousel__template-" + this.props.id));
    this.allCards.forEach(function (template) {
      return template.addEventListener('click', _this2.onTemplateClick);
    });
    this.allCards[0].setAttribute('data-is-active', 'yes');
    this.nextButton = document.getElementById('carousel-next-btn');
    this.prevButton = document.getElementById('carousel-prev-btn');
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        height = _this$props2.height,
        width = _this$props2.width;
    return /*#__PURE__*/React.createElement(Carousel, {
      className: "template-carousel",
      height: height,
      shift: SHIFT_UNIT,
      width: width
    }, this.renderTemplateThumbnails());
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this3 = this;

    this.allCards.forEach(function (template) {
      return template.removeEventListener('click', _this3.onTemplateClick);
    });
  };

  return TemplateCarousel;
}(React.PureComponent);

export { TemplateCarousel as Carousel };
//# sourceMappingURL=index.modern.js.map
